part of pulsar_iot_client.client;

class PulsarClientConsumerActorDelegate implements PulsarClientActorDelegate<ConsumerActor, ConsumerProperties, ConsumerCreateParams, ConsumerCreateResult> {

  @override
  ConsumerActor actorFor({
    required ConsumerProperties properties,
    required PulsarClientActorDescriptor descriptor,
    required Duration rebalanceTime,
    required ClosableActorCallback closableActorCallback
  }) {
    return ConsumerImpl(
      descriptor: descriptor,
      properties: properties,
      rebalanceTime: rebalanceTime,
      closableActorCallback: closableActorCallback,
    );
  }

  @override
  ConsumerProperties propertiesFor({
    required BrokerConnection brokerConnection,
    required Int64 id,
    required ConsumerCreateParams createParams,
    required ConsumerCreateResult createResult
  }) {
    return ConsumerProperties(
      brokerConnection: brokerConnection,
      topic: createParams.topic,
      subscription: createParams.subscription,
      consumerId: id,
      consumerName: createParams.consumerName,
    );
  }

  @override
  Future<ConsumerCreateResult> createActorOnBroker({
    required BrokerConnection brokerConnection,
    required Int64 id,
    required ConsumerCreateParams params
  }) {
    return brokerConnection.createConsumer(id, params);
  }



}
