part of pulsar_iot_client.client;

class PulsarClientProducerActorDelegate implements PulsarClientActorDelegate<ProducerActor, ProducerProperties, ProducerCreateParams, ProducerCreateResult> {

  @override
  ProducerActor actorFor({
    required ProducerProperties properties,
    required PulsarClientActorDescriptor descriptor,
    required Duration rebalanceTime,
    required ClosableActorCallback closableActorCallback
  }) {
    return ProducerImpl(
      descriptor: descriptor,
      properties: properties,
      rebalanceTime: rebalanceTime,
      closableActorCallback: closableActorCallback,
    );
  }

  @override
  ProducerProperties propertiesFor({
    required BrokerConnection brokerConnection,
    required Int64 id,
    required ProducerCreateParams createParams,
    required ProducerCreateResult createResult
  }) {
    return ProducerProperties(
      brokerConnection: brokerConnection,
      topic: createParams.topic,
      producerId: id,
      producerName: createResult.producerName,
    );
  }

  @override
  Future<ProducerCreateResult> createActorOnBroker({
    required BrokerConnection brokerConnection,
    required Int64 id,
    required ProducerCreateParams params
  }) {
    return brokerConnection.createProducer(id, params);
  }

}
