part of pulsar_iot_client.client;

class PulsarClientSettings {
  // broker service URL
  final String serviceUrl;

  // Authentication token provider function (optional)
  final Future<String> Function(String? value)? authTokenProvider;
  // Authentication token refresh support flag
  final bool authTokenRefreshSupported;

  // TLS security settings (optional)
  final bool forceTLS;
  final SecurityContext? securityContext;
  final bool Function(X509Certificate)? onBadCertificate;

  // silent re-connection settings
  int maxConnectionAttempts;
  // socket-level reconnect time
  Duration reconnectTime;

  // maximum request redirect count. Must be > number of brokers in the cluster
  int maxRedirects;
  // expected (topic) rebalance time
  Duration rebalanceTime;
  // maximum (topic) rebalance time on the producer high-level prospect
  Duration rebalanceTimeMax;

  PulsarClientSettings({
    this.serviceUrl = 'pulsar://localhost:6650/',
    this.authTokenProvider,
    this.authTokenRefreshSupported = true,
    this.forceTLS = false,
    this.securityContext,
    this.onBadCertificate,
    this.maxConnectionAttempts = 1,
    this.reconnectTime = const Duration(milliseconds: 2000),
    this.rebalanceTime = const Duration(milliseconds: 1000),
    this.rebalanceTimeMax = const Duration(milliseconds: 5000),
    this.maxRedirects = 4,
  });
}
